;*********************************************
;2005.12.16
; sterownik swiatel na choinke
;*********************************************
;stale programowe
;*********************************************
;*********************************************
;SKOPIOWAC STEROWANIE LCD I STALE PROG.
; sterownik co; termometr LCD
;INIT_LCD - 4 BIT
;matryca 1x16
;wersja testowa mz procedura pomiaru
;*********************************************
;stale programowe
;*********************************************
DELAY_TIME EQU 03CH; inc co 100us
KEY_CODE EQU 03BH ;kod klawisza
h_stop EQU 03AH ;godziny
m_stop EQU 039H ;minuty
h_start EQU 038H ;godziny
m_start EQU 037H ;minuty
h EQU 036H ;godziny
m EQU 035H ;minuty
s EQU 034H ; jednostki sekund
msx100 EQU 033H ; setki mili sekund
msx10 EQU 032H ; dziesiatki mili sekund
msx1 EQU 031H ; jednostki mili sekund
usx100 EQU 030H ; setki mikro sekund
START_BIT EQU 020H.0 ;bit wlaczajacy test zegara
DB_LED EQU P1 ; busy bit LCD
KEY EQU P3.5
timer0 EQU 0206 ;zawarto TH i TL (6MHz)
;*********************************************
;        obsluga przerwania od timera T0
;*********************************************
	AJMP START
	ORG 0BH
	PUSH PSW
	PUSH ACC
	MOV A,usx100
	INC A
	MOV usx100,A
	CJNE A,#0AH,TIMER_END
	MOV usx100,#00H
	DEC DELAY_TIME 
	MOV A,msx1
	INC A
	MOV msx1,A
	CJNE A,#0AH,TIMER_END
	MOV msx1,#00H
	MOV A,msx10
	INC A
	MOV msx10,A
	CJNE A,#0AH,TIMER_END
	MOV msx10,#00H
	MOV A,msx100
	INC A
	MOV msx100,A
	CJNE A,#0AH,TIMER_END
	MOV msx100,#00H
	MOV A,s
	INC A
	MOV s,A
	CJNE A,#060,TIMER_END
	MOV s,#00H
	LCALL TIMER
TIMER_END:
	POP ACC
	POP PSW
TIMER_END1:
	RETI
	ORG 100H
;****************************************************
;                 program glowny
;****************************************************
START:		
	MOV TCON,#00H  zezwolenie na timer0
	; TCON = TF1,TR1,TF0,TR0,IE1,IT1,IE0,IT0
	;TF1 -wsk. przerwania od licznika T1, ustawiany
	;	sprzetowo po przepelnieniu T1 i zerowany
	;	sprzetowo po przejsciu do procedury obslugi T1
	;TR1=1 - licznik T1 ON
	;TF0 ; TR1 tj. w. dla T0
	;IE1- wskaznik przewania zewnetrzego 'INIT1 kasowany
	;	w chwili przejscia do procedury obslugi
	;IT1=0 - reaguje na niski poziom INIT1
	;IT1=1 - reaguje na opadajace zbocze INIT1
	;IE0; IT0 tj w. dla INIT0
	;********************************************
	MOV TMOD,#022H;32H  liczniki t0 w trybie 2
	;GATE1,C/'T1,M11,M10,GATE0,C/'T0,M01,M00
	;GATE1=0=>zliczanie t1 <=> TR1=1
	;GATE1=1=>zliczanie t1 <=> TR1=1 i 'INIT1=1
	;C/'T1=0 => T1 zegar systemowy
	;C/'T1=1 => T1 licznik impulsow z 'INIT1
	;M11M10=00 -tryb0 licznik 8bit z 5bit preskaler
	;M11M10=01 -tryb1 licznik 16bit
	;M11M10=10 -tryb2 8 bit z auto load TL1:=TH1
	;M11M10=00 -tryb3 wstrzymanie zliczania
	;GATE0,C/'T0,M01,M00 tj. w. dla T0
	;********************************************
	MOV TL0,#timer0 
	MOV TH0,#timer0 ;timer0 przepelni sie po 100us
	MOV IE,#08AH ;
	MOV DB_LED,#00H
	MOV h_stop,#00H ;godziny
	MOV m_stop,#00H ;minuty
	MOV h_start,#017H ;godziny
	MOV m_start,#00H ;minuty
	MOV h,#012H ;godziny
	MOV m,#00H ;minuty
	MOV s,#00H ; jednostki sekund
	MOV msx100,#00H ; setki mili sekund
	MOV msx10,#00H ; dziesiatki mili sekund
	MOV msx1,#00H ; jednostki mili sekund
	MOV usx100,#00H ; setki mikro sekund
	;SETB START_BIT
	CLR START_BIT
	SETB TR0
POCZ0:
	ACALL CLOCK_SET
POCZ1:
	MOV DB_LED,#10000000B
	MOV A,PCON ;!!!!!!!!!!!!!
	SETB ACC.0
	MOV PCON,A ;!!!!!!!!!! BIT IDL
	MOV C,START_BIT
	JNC POCZ1; ustawiany przez timer
	CLR P1.7;!!!!!!!!!!!!!!!!!
	ACALL RIGHT
	ACALL BLINK
	ACALL STILL
	ACALL LEFT
	ACALL BLINK
	ACALL STILL
	SJMP POCZ1
;****************************************
; obsluga timera
TIMER:
	MOV A,m
	ADD A,#01H
	DA A
	MOV m,A
	CJNE A,#060H,ENDT0
	MOV m,#00H
	MOV A,h
	ADD A,#01H
	DA A
	MOV h,A
	CJNE A,#024H,ENDT0
	MOV h,#00H
ENDT0:
	MOV A,h
	CJNE A,h_stop,TIMER0
	MOV A,m
	CJNE A,m_stop,TIMER0
	;WSTRZYMANIE CYKLU
	CLR START_BIT
	SJMP ENDT_END
TIMER0:
	MOV A,h
	CJNE A,h_start,ENDT_END
	MOV A,m
	CJNE A,m_start,ENDT_END
	;ROZPOCZENCIE CYKLU
	SETB START_BIT
ENDT_END:
	RET
;******************************************
;LICZNIK JONSONA W PRAWO
RIGHT:
	PUSH ACC
	PUSH B
	MOV DB_LED,#00H
	MOV A,#00H
	MOV B,#08H
RIGHT1:
	ACALL DELAY100
	ACALL DELAY100
	SETB C
	RLC A
	;PUSH ACC
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	;ACALL DELAY100
	;ACALL DELAY100
	DJNZ B,RIGHT1
	POP B
	POP ACC
	RET
;******************************************
;LICZNIK JONSONA W LEWO
LEFT:
	PUSH ACC
	PUSH B
	MOV A,#0FFH
	MOV B,#09H
LEFT1:
	ACALL DELAY100
	ACALL DELAY100
	CLR C
	RRC A
	MOV DB_LED,A
	CLR P1.7
	;ACALL DELAY100
	DJNZ B,LEFT1
	POP B
	POP ACC
	RET
;******************************************
;TRZY BLYNICIA
BLINK:
	PUSH B
	MOV B,#03H
BLINK1:
	MOV DB_LED,#01111111B
	ACALL DELAY100
	ACALL DELAY100
	MOV DB_LED,#00H
	ACALL DELAY100
	ACALL DELAY100
	DJNZ B,BLINK1
	POP B
	RET
;*******************************************
;CIAGLE SWIATLO PRZEZ 1s
STILL:
	PUSH B
	MOV B,#20
	MOV DB_LED,#01111111B
STILL1:
	ACALL DELAY100
	DJNZ B,STILL1
	POP B
	RET
;********************************************
; wprowadzanie danych
;start cyklu HH:MM
;stop cyklu HH:MM
;aktualny czas HH:MM
;czy cykl jest w trakcie
;********************************************
CLOCK_SET:
	CLR P1.7;!!!!!!!!!!!!
	MOV A,s
	CJNE A,#030H,CLOCK_SET0
	AJMP CLOCK_SET_END
CLOCK_SET0:
	MOV DB_LED,h_start
	CLR P1.7;!!!!!!!!!!!!!
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET
	CJNE A,#0FH,CLOCK_SET1A
	MOV A,h_start	;godziny aktualnego czasu
	ADD A,#01H
	DA A
	CJNE A,#024H,CLOCK_SET1
	MOV A,#00H
CLOCK_SET1:
	MOV h_start,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET
CLOCK_SET1A:
	MOV DB_LED,m_start
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET2:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET2
	CJNE A,#0FH,CLOCK_SET4
	MOV A,m_start ;minutu aktualnego czasu
	ADD A,#01H
	DA A
	CJNE A,#060H,CLOCK_SET3
	MOV A,#00H
CLOCK_SET3:
	MOV m_start,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET2
CLOCK_SET4:
	ACALL BLINK
	MOV DB_LED,h_stop
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET5:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET5
	CJNE A,#0FH,CLOCK_SET6A
	MOV A,h_stop ;godziny poczatku cyklu
	ADD A,#01H
	DA A
	CJNE A,#024H,CLOCK_SET6
	MOV A,#00H
CLOCK_SET6:
	MOV h_stop,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET5
CLOCK_SET6A:
	MOV DB_LED,m_stop
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET7:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET7
	CJNE A,#0FH,CLOCK_SET8A
	MOV A,m_stop; minutu poczatku cyklu
	ADD A,#01H
	DA A
	CJNE A,#060H,CLOCK_SET8
	MOV A,#00H
CLOCK_SET8:
	MOV m_stop,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET7
CLOCK_SET8A:
	ACALL BLINK
	MOV DB_LED,h
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET9:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET9
	CJNE A,#0FH,CLOCK_SET10A
	MOV A,h ;godziny konca cyklu
	ADD A,#01H
	DA A
	CJNE A,#024H,CLOCK_SET10
	MOV A,#00H
CLOCK_SET10:
	MOV h,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET9
CLOCK_SET10A:
	MOV DB_LED,m
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET11:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET11
	CJNE A,#0FH,CLOCK_SET12A
	MOV A,m ;minuty konca cyklu
	ADD A,#01H
	DA A
	CJNE A,#060H,CLOCK_SET12
	MOV A,#00H
CLOCK_SET12:
	MOV m,A
	MOV DB_LED,A
	CLR P1.7;!!!!!!!!!!!!!
	SJMP CLOCK_SET11
CLOCK_SET12A:
	ACALL BLINK
	MOV DB_LED,#00H
	CLR P1.7;!!!!!!!!!!!!!
CLOCK_SET13:
	ACALL KEY_TEST
	MOV A,KEY_CODE
	JZ CLOCK_SET13
	CJNE A,#0FFH,CLOCK_SET14
	SETB START_BIT
	SJMP CLOCK_SET_END
CLOCK_SET14:
	CLR START_BIT
CLOCK_SET_END:
	MOV s,#00H ; jednostki sekund
	MOV msx100,#00H ; setki mili sekund
	MOV msx10,#00H ; dziesiatki mili sekund
	MOV msx1,#00H ; jednostki mili sekund
	MOV usx100,#00H ; setki mikro sekund
	SETB P1.7;!!!!!!!!!!!!!!!!!!
	RET
;*****************************
;procedura odczytu klawisza
;zwraca pod KEY_COD: 00h wolny
;0FH short, FFH long
KEY_TEST:
	MOV KEY_CODE,#00H ;wyzerowanie
	SETB KEY
	MOV C,KEY
	JC END_KEY_TEST
	MOV KEY_CODE,#0FH ;short
	PUSH ACC
	MOV ACC,#05; 0,5s
KEY_TEST1:
	LCALL DELAY100
	DEC A
	JZ KEY_TEST2
	MOV C,KEY
	JNC KEY_TEST1
	AJMP END1_KEY_TEST
KEY_TEST2:
	MOV KEY_CODE,#0FFH ;long
	SETB KEY
KEY_TEST21:
	LCALL DELAY100 ;buz on 10ms
	MOV C,KEY
	JNC KEY_TEST21
END1_KEY_TEST:
	POP ACC
END_KEY_TEST:
	CLR C
	RET;
;************************************
; opnienie o 10ms
DELAY10:
	PUSH ACC
	MOV DELAY_TIME,#0AH
DELAY11:
	MOV A,DELAY_TIME
	JNZ DELAY11
	POP ACC
	RET
;************************************
; opnienie o 100ms
DELAY100:
	PUSH ACC
	MOV DELAY_TIME,#100
DELAY101:
	MOV A,DELAY_TIME
	JNZ DELAY101
	POP ACC
	RET
;************************************
; opnienie o A*1ms
DELAYX:
	MOV DELAY_TIME,A
DELAYX1:
	MOV A,DELAY_TIME
	JNZ DELAYX1
	RET
